:
# userumask.sh
# version 3.0 Sep 25 11:21:02 PDT 1998
# version 3.0.1 Mon Dec 14 10:53:10 PST 1998 change line 114 to check for "^" 
# version 3.0.5 Tue Feb 16 14:55:17 PST 1999 change contributed by Jason R. Rhoads
# change incorporates a variable for the UMASK setting;  UMASK=027 or UMASK=022
# version 3.4 Wed Feb 16 08:33:18 PST 2000 savefile variable added
# version 4.0.10 Sol8 also uses CMASK in /etc/default/init

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1994, 1995, 1996, 1997, 1998, 1999, 2000, 2001
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 
#
# Mitko Stoyanov September 1999
# Disabled checking/fixing UMASK in /etc/default/login, there is a separate
# module working on all settings in /etc/default/login.
#

#setup  dont change this unless you want to do some work on the script
IFS=:
TITANHOME=`pwd`
PATH=/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`
DATE=`/bin/date +%m%d%y%H%M`
SAVEFILES='/etc/.login /etc/profile /etc/skel/local.cshrc /etc/skel/local.login /etc/skel/local.profile /etc/default/login'
OS=`uname -r`

# umask setting: set to whatever your local security policy dictates 
# bpowell note; my personal umask is set to 077 
# UMASK=022 creates files with mode -rw-r--r-- 
# UMASK=027 creates files with mode -rw-r-----
# UMASK=077 creates files with mode -rw-------
# default
UMASK=022

# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi
 
. misc_functions.sh

Intro() {

cat << EOFM

 $MYNAME - This programs adds umask $UMASK to startup files for users shell
 in /etc and /etc/skel as appropriate and UMASK=$UMASK in /etc/default/login
 and in solaris 8 /etc/default/init CMASK

EOFM
}

Fix() {

for FILE in /etc/.login /etc/profile /etc/skel/local.cshrc /etc/skel/local.login /etc/skel/local.profile /etc/default/login

 do
 if [ -f ${FILE} ]; then
t_echo 2 " Adding umask $UMASK to ${FILE}...."

ed - ${FILE} << EOEF
1
/^.*/s/^.*/umask $UMASK/
w
q
EOEF

 else
t_echo 2 " File ${FILE} does not exist - passing"
 fi

done

# handle upper case UMASK

if [ -f /etc/default/login ] ; then
 t_echo 2 " Adding UMASK=$UMASK to /etc/default/login...."
 
ed - /etc/default/login << EOEF
1
/^.*/s/^.*/UMASK=$UMASK/
.
w
q
EOEF

fi


# handle CMASK
 
 if [ -f /etc/default/init ]; then
  t_echo 2 " Adding CMASK=$UMASK to /etc/default/init...."
 
ed - /etc/default/init << EOEF
1
/^.*/s/^.*/CMASK=$UMASK/
w
q

EOEF
 
 else
t_echo 2 " File /etc/default/init does not exist - passing"
 fi
 

t_echo 2 ""

}

Check() {

t_echo 2 " Checking for umask $UMASK in : "
for FILE in  /etc/.login  /etc/default/login /etc/profile /etc/skel/local.cshrc /etc/skel/local.login /etc/skel/local.profile
 do
t_echo 2 " ${FILE}"
done
t_echo 3 ""

for FILE in /etc/.login /etc/.login /etc/profile /etc/skel/local.cshrc /etc/skel/local.login /etc/skel/local.profile
 do
 if [ -f ${FILE} ]; then
 if [ `grep "umask $UMASK" ${FILE}` ]; then
  t_echo 1 "Umask value $UMASK in ${FILE} - PASSES CHECK"
 else
  t_echo 0 "Umask value other than $UMASK in ${FILE} - FAILS CHECK"
        t_echo 3 " "
        t_echo 3 "Titan Recommendation: (userumask.sh -f) Add a umask 022 to startup files for"
        t_echo 3 "users shell in /etc and /etc/skel as appropriate and UMASK=022 in"
        t_echo 3 "/etc/default/login "
        t_echo 3 " "
        t_echo 3 "======================================================================== "

 fi
 else
t_echo 3 "       File ${FILE} does not exist - skipping"
 fi

done
t_echo 3 ""

for FILE in /etc/default/init
 do
 if [ -f ${FILE} ]; then 
 if [ `grep "^\s*CMASK=$UMASK" ${FILE}` ]; then
 t_echo 1 "CMASK value $UMASK in ${FILE} - PASSES CHECK"
 else
  t_echo 0 "CMASK value other than $UMASK in ${FILE} - FAILS CHECK"
 fi
 else
t_echo 3 "       File ${FILE} does not exist - skipping"
 fi
done

}

#
# Main section here
#
action=$1
case $action in
	-[Ii]*)
	 Intro
	;;
	 -[Ff]*)
	 Fix
	;;
	-[Vv]*)
	 Check
	;;
	*)
        t_echo 1 "       ERROR:Invalid arg $action"
        t_echo 1 "       ERROR:Usage $MYNAME -[ivf] (I)ntro/(V)erify/(F)ix"
        t_echo 1 " "
;;
esac
