:
# automount.sh
# version 3.0 Sep 25 11:21:02 PDT 1998
# version 3.0.1  bpowell Mon Jan  4 13:04:08 PST 1999 changed 
# version 3.4 Wed Feb 16 08:33:18 PST 2000 savefile variable added
# lines number 46, 59, and 72 from "grep -v" to "sed" to work with white spaces
# fix recommended by Porter Taylor 
# version 4.0

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1994, 1995, 1996, 1997, 1998, 1999, 2000
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 

# setup
TITANHOME=`pwd`
PATH=/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`
DATE=`/bin/date +%m%d%y%H%M`
RUNDATE=`/bin/date +%m%d%y%H%M%S`
SAVEFILES='/etc/rc.nfs'
AUTOCONFILE='/etc/rc.nfs'
OS=`uname -r`

# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi

. misc_functions.sh

Intro() {

cat << EOF
 $MYNAME - This program modifies /etc/rc.nfs so that automounter
  does not start at system boot by commenting out the following line(s).

	## Begin AutoFS startup   ## Do NOT remove
	##
	if [ -s /etc/auto_master ]; then
        /usr/sbin/automount
	fi
	##
	## End AutoFS startup   ## Do NOT remove

EOF

}

Fix() {

if [ -f ${AUTOCONFILE} ]; then

   /bin/cp ${AUTOCONFILE} ${AUTOCONFILE}-preTitan-${RUNDATE}

   AUTOFS=`grep -s "[ ,	]/usr/sbin/automount" ${AUTOCONFILE} | grep -v "#" | awk '{print $1}'`

if [ -z "$AUTOFS" ]; then
  t_echo 1 "        No automounter entry - PASSES CHECK "
  exit 1
else
  t_echo 2 "        System automounter enabled REPAIRING Now"
ed - ${AUTOCONFILE} << EOEF
g/\/usr\/sbin\/automount/s/\/usr\/sbin\/automount/#\/usr\/sbin\/automount/g
a
echo "automount disabled"
.
w
q
EOEF

   AUTOFS=`grep -s "[ ,	]/usr/sbin/automount" ${AUTOCONFILE} | grep -v "#" | awk '{print $1}'`

 t_echo 2 "        Automounter = $AUTOFS "
fi

else
  t_echo 1 "         File ${AUTOCONFILE} doesn't exist - CHECK ERROR"
exit 1
fi
}


Check() {

if [ -f ${AUTOCONFILE} ]; then

   AUTOFS=`grep -s "[ ,	]/usr/sbin/automount" ${AUTOCONFILE} | grep -v "#" | awk '{print $1}'`

if [ -z "${AUTOFS}" ]; then
  t_echo 1 "        No automounter configured - PASSES CHECK"
  else
  t_echo 0 "         Automounter = ${AUTOFS} - FAILS CHECK"
  fi
else
  t_echo 1 "         File ${AUTOCONFILE} doesn't exist - CHECK ERROR"
exit 1
fi

}


action=$1
	case ${action} in
	-[Ii]*)
	Intro
	;;
	 -[Ff]*)
	Fix
	;;
	-[Vv]*)
	Check
	;;
	*)
        t_echo 1 "        ERROR:Invalid arg $action"
        t_echo 1 "        ERROR:Usage $MYNAME -[ivf] (I)ntro/(V)erify/(F)ix"
        t_echo 1 " "
	;;
	esac
#finis
