:
# disable-core.sh
# version 3.0 Sep 25 11:21:02 PDT 1998
# version 3.0.3 Fri Jan  8 18:42:25 PST 1999 bpowell
# version 3.4 Wed Feb 16 08:33:18 PST 2000 savefile variable added
# version 4.0

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1994, 1995, 1996, 1997, 1998, 1999, 2000
#
# The copyright holder disclaims all responsibility or liability with
# respect to its usage or its effect upon hardware or computer
# systems, and maintains copyright as set out in the "LICENSE"
# document which accompanies distribution.

# setup
TITANHOME=`pwd`
PATH=/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`
DATE=`/bin/date +%m%d%y%H%M`
RUNDATE=`/bin/date +%m%d%y%H%M%S`
SAVEFILES='/etc/system'
CORECONF='/etc/security/limits'


# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi
 
#
# suck in some lib functions (t_echo 2, etc.)
#
. misc_functions.sh

Intro() {

cat << EOF

$MYNAME : This changes the /etc/security/limits file making the core dump size
limited to zero length. This prevents bad-guys forcing a core dump to examine
any information that might be stored in the core. Reference the old
bug where you could force a core with gcore of processes like rpc.pwauthd

EOF

}

Check() {

if [ -r ${CORECONF} ]; then

 # t_echo 2 "Located $CORECONF continue..."
   CORELIM=`/usr/bin/lssec -f ${CORECONF} -s default -a core | awk -F"=" '{print $NF}'`
 #   t_echo 2 "Core limit current = $CORELIM"
    if [ ${CORELIM} -ne 0 ]; then
	t_echo 1  "	Core limit = ${CORELIM} - FAILS CHECK"
        else
 	t_echo 1  "	Core limit = ${CORELIM} - PASSES CHECK"
    fi
    else
   t_echo 1  "	Could not locate ${CORECONF} - CHECK ERROR"
fi
}

Fix() {
if [ -r ${CORECONF} ]; then

  /bin/cp ${CORECONF} ${CORECONF}-preTitan-${RUNDATE}
  # t_echo 2 "Fix located $CORECONF continue..."
   CORELIM=`/usr/bin/lssec -f ${CORECONF} -s default -a core | awk -F"=" '{print $NF}'`
    # t_echo 2 "Core limit current = $CORELIM"
    if [ ${CORELIM} -ne 0 ]; then
	t_echo 1  "	Core limit = ${CORELIM} - FAILS CHECK"
	t_echo 2  "	Core limit repair in progress"
         /usr/bin/chsec -f ${CORECONF} -s default -a core=0
        else
 	t_echo 1  "	Core limit = ${CORELIM} - PASSES CHECK"
    fi
    else
   t_echo 1  "        Could not locate ${CORECONF} - CHECK ERROR"
fi

# Run check again to see if we fixed this....
Check

}

action=$1
 
   case ${action} in
        -[Ii]*)
        Intro
        ;;
        -[Ff]*)
        Fix
        ;;
        -[Vv]*)
        Check
        ;;
        *)
        t_echo 1 "        ERROR:Invalid arg $action"
        t_echo 1 "        ERROR:Usage $0 -[ivf] (I)ntro/(V)erify/(F)ix"
        exit 1
	;;
        esac


