:
# inetd2.sh
# version 3.4 Wed Feb 16 08:33:18 PST 2000 savefile variable added
# version 4.0
umask 022

# This tool suite was written by and is copyright by Brad Powell , Matt 
# Archibald, and Dan Farmer 1994, 1995, 1996, 1997, 1998, 1999, 2000
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 
 
# Some of the ideas and code for the sunos 4.1.X version of titan was 
# modified from code from a program secure_sun author unknown. If the 
# author of secure_sun (i believe it was from Texas A&M) wishes to identify 
# himself/herself I will gladly post credit where it is due- bpowell
 
# setup
TITANHOME=`pwd`
PATH=/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`
OS=`uname -r`
HOST=`uname -n`
DATE=`/bin/date +%Y%m%d%H%M`
RUNDATE=`/bin/date +%Y%m%d%H%M%S`
SAVEFILES='/etc/inetd.conf /etc/inet/inetd.conf'
INETCONF="/etc/inetd.conf"

#
# suck in some lib functions (t_echo, etc.)
#
. misc_functions.sh

# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
	# exit 1
	:
	fi

Intro() {

cat << EOF_INTRO

 $MYNAME : This is a more restrictive version of inetd.sh. It disables all
 but telnet and ftp in $INETCONF, since they give out information or are 
 potential "denial of service" problems, Things like rexd, finger, systat,
 netstat, rusersd, sprayd, and walld are disabled.
 Additionally in.ftpd gets started with "-l" to log all ftp sessions.

EOF_INTRO

}

Check() {
 
if egrep -s "^finger|^talk|^comsat|^shell|^login|^uucp|^tftp|^name|^printer|^shell|^login" $INETCONF
then
   t_echo 0 " File $INETCONF has services running that should be disabled - FAILS CHECK"
else
   t_echo 1 " $INETCONF seems to have had services disabled: PASSES CHECK"

fi

}

Fix() {

if [ -f $INETCONF.ORIG ]
	then
	t_echo 2 "File $INETCONF.ORIG already exists; not changing"
else
	t_echo 0 "moving $INETCONF to $INETCONF.ORIG.$DATE"
	mv $INETCONF $INETCONF-preTitan-$RUNDATE
	if [ $? -ne 0 ]
		then   
		t_echo 2
		t_echo 2 "Could not rename inetd.conf"
		exit 1
		fi
	fi

if [  ! -f $INETCONF ]
	then
	t_echo 0 "Changing $INETCONF to the new version"
	t_echo 0 "Note: You may have to manually edit inetd if you add"
	t_echo 0 "non-standard services."
	t_echo 0 "The existing version is saved as $INETCONF.ORIG.$DATE"
	t_echo 0 ""
	t_echo 0 " YOU SHOULD REALLY LOOK TO USING ssh or logdaemon!"

/bin/cat << EOF_INET > $INETCONF

# Titan Security Toolkit(R) - Configuration file for inetd(8).  See inetd.conf.
#
# To re-configure the running inetd process, edit this file, then
# send the inetd process a SIGHUP.
#
# Internet services syntax:
#  <service_name> <socket_type> <proto> <flags> <user> <server_pathname> <args>
#
# Ftp and telnet are standard Internet services.
#
ftp    stream    tcp6    nowait    root    /usr/sbin/ftpd    ftpd
telnet    stream    tcp6    nowait    root    /usr/sbin/telnetd    telnetd -a

#
#
# shell    stream    tcp6    nowait    root    /usr/sbin/rshd    rshd
# login    stream    tcp6    nowait    root    /usr/sbin/rlogind    rlogind
# exec    stream    tcp6    nowait    root    /usr/sbin/rexecd    rexecd
# daytime    stream    tcp    nowait    root    internal
# time    stream    tcp    nowait    root    internal
# daytime    dgram    udp    wait    root    internal
# time    dgram    udp    wait    root    internal

# xmquery dgram   udp     wait    root    /usr/bin/xmservd xmservd -p3
# wsmserver       stream  tcp     nowait  root    /usr/websm/bin/wsmserver wsmserver -start

EOF_INET

	/bin/chmod 644 $INETCONF
	fi

}

action=$1
case $action in
 -[Ff]*)
Fix
;;
 -[Vv]*)
Check
;;
 -[Ii]*)
Intro
;;
 
*)
        t_echo 1 "        ERROR:Invalid arg $action"
        t_echo 1 "        ERROR:Usage $MYNAME -[ivf] (I)ntro/(V)erify/(F)ix"
        t_echo 1 " "
;;
esac

