:
# nuke dtlogin.sh
# version 4.0 Wed Feb 16 08:33:18 PST 2000

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1994, 1995, 1996, 1997, 1998, 1999, 2000, 2001, 2002
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 

# setup
TITANHOME=`pwd`
PATH=/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`
DATE=`/bin/date +%m%d%y%H%M`
RUNDATE=`/bin/date +%m%d%y%H%M%S`
SAVEFILES='/etc/rc.nfs'
NFSCONF='/etc/rc.nfs'

OS=`uname -r`

# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi

#
# suck in some lib functions (t_echo, etc.)
#
. misc_functions.sh

Intro() {

cat << EOF

 $MYNAME : This program checks/modifies /etc/rc.nfs to ensure that NFSD
 and hence the NFS Server does not start at system boot.
 
 When run in Fix mode we comment out the startup line and insert an entry
 that will simply echo NFSD not started during rc.nfs sequence.

EOF

}

Fix() {

if [ -f ${NFSCONF} ]; then
   cp ${NFSCONF} ${NFSCONF}-preTitan-${RUNDATE}

    NFSON=`grep "start nfsd" ${NFSCONF} | grep -v "#"`
     if [ -z "${NFSON}" ]; then
     t_echo 3 "         NFS Server not started at boot time - PASSES CHECK "
      else
     t_echo 3 "         NFS Server started at boot time - FAILS CHECK "
     t_echo 2 "	Copied ${NFSCONF} to ${NFSCONF}-preTitan-${RUNDATE}"
     t_echo 0 "	Modifying ${NFSCONF} to comment out nfsd startup"
	ed - ${NFSCONF} <<- EOF
	g/start nfsd/s/^/#/g
        g/\/usr\/sbin\/exportfs -a/s/^/#/g
        g/start rpc.mountd/s/^/#/g
	a
	echo "nfsd not started"
	echo "exportfs not initiated"
	echo "rpc.mountd not started"
	.
	w
	q
	!
	EOF
      fi
    Check
else
  t_echo 1 "	NFS Server doesn't start at boot - PASSES CHECK" 
fi

}


Check() {

if [ -f ${NFSCONF} ]; then
  t_echo 0 "         File ${NFSCONF} exists. Checking for nfsd start.."
    NFSON=`grep "start nfsd" ${NFSCONF} | grep -v "#"`
     if [ -z "${NFSON}" ]; then
     t_echo 0 "         NFS Server not started at boot time - PASSES CHECK "
      else
     t_echo 0 "         NFS Server started at boot time - FAILS CHECK "
        t_echo 0 " "
        t_echo 0 " Titan Recommendation: (nuke-nfs-serv.sh -f) NFS server is not needed on"
        t_echo 0 " Desktops, Servers or Firewalls (except for specific NFS Servers). "
	t_echo 0 " It should be disabled to prevent the NFS server from being able to start." 
        t_echo 0 " "
     fi
fi

}


action=$1
	case ${action} in
	-[Ii]*)
	Intro
	;;
	 -[Ff]*)
	Fix
	;;
	-[Vv]*)
	Check
	;;
	*)
        t_echo 1 "        ERROR:Invalid arg $action"
        t_echo 1 "        ERROR:Usage $MYNAME -[ivf] (I)ntro/(V)erify/(F)ix"
        t_echo 1 " "
	;;
	esac
