:
# smtpbanner-8.8.sh
# version 3.0 Sep 25 11:21:02 PDT 1998
# revision 3.0.1 brad powell Sept 28 11:21:02 PDT 1998
# version 3.0.1 brad powell Mon Dec 14 10:53:10 PST 1998 line 72 
# change output to match actual check
# version 3.4 Wed Feb 16 08:33:18 PST 2000 savefile variable added
# version 4.0.10 Wed Apr 25 09:45:46 PDT 2001
# incoproprated enhancements from richter_jk@hotmail.com and michael@netsys.co.nz

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1994, 1995, 1996, 1997, 1998, 1999, 2000, 2001
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 

# setup
TITANHOME=`pwd`
PATH=/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`
DATE=`/bin/date +%m%d%y%H%M`
SAVEFILES='/etc/mail/sendmail.cf'
OS=`uname -r`

# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi

. misc_functions.sh

case "`uname -r`" in
5.[6789]*) ;;
*)
        t_echo 1 "$MYNAME ERROR - This script is Only supported on patched Solaris 2.6 and newer, please use one of the other scripts for your OS "
        exit 1;;
esac
 
# from michael@netsys.co.nz
# check to see if sendmail version isn't too old for the script
if grep DVSMI-SVR4  /etc/mail/sendmail.cf > /dev/null ; then
  t_echo 1 "$MYNAME : ERROR - sendmail isn't patched!!"       
        exit 1                                                
fi      

Intro() {
cat << EOF

 $MYNAME - This changes the sendmail version 8.8 banner to not report
 what mail version is running. It changes your login banner from something 
 like This:
 
	Sendmail SMI-8.8/SMI-SVR4 ready at Fri, 2 May 1997

		TO

     	Sendmail Server Ready

EOF
}

Check() {

if [ -f /etc/mail/sendmail.cf ]; then

  t_echo 3 " File /etc/mail/sendmail.cf exists - Checking content"
  grep "^O\ SmtpGreetingMessage=\$j\ Sendmail\ \$v\/\$Z\;\ \$b" /etc/mail/sendmail.cf >/dev/null

  if [ $? -ne 0 ]; then
   t_echo 1 "         sendmail banner has been modified  - PASSES CHECK"
   exit 1
  else
   t_echo 0 "         Sendmail Server Banner is generic  - FAILS CHECK"
  fi
fi

}

Fix() {
 
if [ -f /etc/mail/sendmail.cf ]; then
   t_echo 3 " File /etc/mail/sendmail.cf exists - Checking content"
   grep "^O\ SmtpGreetingMessage=\$j\ Sendmail\ \$v\/\$Z\;\ \$b" /etc/mail/sendmail.cf >/dev/null
 
   if [ $? -ne 0 ]; then
      t_echo 1 "         sendmail banner has already been modified  - PASSES CHECK"
      exit 1
   else
      t_echo 2 "         Sendmail Server Banner is generic  - Correcting"
      cp /etc/mail/sendmail.cf /etc/mail/sendmail.cf.Titan.$DATE >/dev/null
 
   if [ $? -eq 0 ]; then
      t_echo 2 " Changing the Sendmail Ready line "
	ed - /etc/mail/sendmail.cf <<- !
	g/^O\ SmtpGreetingMessage=\$j\ Sendmail\ \$v\/\$Z;\ \$b/s//O\ SmtpGreetingMessage=\ Sendmail\ ready /
	w
	q
	!
 
	t_echo 2 "     "
	t_echo 2 " Sendmail login message changed"
	t_echo 2 "     "
   else
 	t_echo 1 " Could not backup /etc/mail/sendmail.cf - ERROR"
  exit 1
  fi
 fi
fi 
}

action=$1
case $action in
	-[Ii]*)
	Intro
	;;
	 -[Ff]*)
	 Fix
	;;
	-[Vv]*)
	 Check
	;;
	*)
        t_echo 1 "         ERROR:Invalid arg $action"
        t_echo 1 "         ERROR:Usage $MYNAME -[ivf] (I)ntro/(V)erify/(F)ix"
        t_echo 1 " "
;;
esac
