:
#
# version 3.0 Sep 25 11:21:02 PDT 1998
# version 3.0.3 Fri Jan  8 18:42:25 PST 1999 bpowell

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1992, 1993, 1994, 1995, 1996, 1997, 1998, 1999, 2000
#
# The copyright holder disclaims all responsibility or liability with
# respect to its usage or its effect upon hardware or computer
# systems, and maintains copyright as set out in the "LICENSE"
# document which accompanies distribution.

# RedHat fixes donated by Kirby Kuehl. 

# setup
TITANHOME=`pwd`
PATH=/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`
DATE=`/bin/date +%m%d%y%H%M`

# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi
 
#
# suck in some lib functions (t_echo, etc.)
#
. misc_functions.sh

case `uname` in
 linux|Linux)
       t_echo 2 "  Checking linux core limit "
 ;;
 *)
       t_echo 0 "  Only supported on Linux OS.."
 ;;
esac
 

FUNCTIONS="/etc/rc.d/init.d/functions"

Intro() {

cat << EOF

This changed the /etc/rc.d/init.d/functions file making the core dump size limited
to zero length. This prevents bad-guys forcing a core dump to examine
any information that might be stored in the core. Reference the old
bug where you could force a core with gcore of processes like rpc.pwauthd

EOF

}

Fix() {
        if [ -f "$FUNCTIONS" ] ; then
        t_echo 2 "   $FUNCTIONS exists "
        t_echo 2 "   saving a copy of the old $FUNCTIONS  $FUNCTIONS.$DATE"
        cp $FUNCTIONS $FUNCTIONS.$DATE 
                if [ $? -ne 0 ]
                then
                        t_echo 1
                        t_echo 1 "Could not rename $FUNCTIONS; exiting"
                        exit 1
                fi
        fi
 
# if the file isn't there create it
 
        if [  ! -f "$FUNCTIONS" ] ; then
        t_echo 0 "   Creating $FUNCTIONS and limiting core files"
        /bin/cat << EOF2 > $FUCNTIONS
 
        * added zero to limit core files size for most init.d & rc.d scripts
        ulimit -c 0

EOF2
fi

# if the file is there append to it

if [  -f $FUNCTIONS -a -z `grep "ulimit -S -c 0" $FUNCTIONS` ]; then
        t_echo 0 "   Changing $FUNCTIONS to limit core filesize"
        /bin/cat << EOF3 >> /etc/system

        * added zero to limit core files size for most init.d & rc.d scripts
        ulimit -c 0

EOF3

	t_echo 2 "   Core files have been disabled"
        else
        t_echo 0 "   Core dump size has not been set:  FAILS CHECK "
fi

/bin/chmod 644 $FUNCTIONS
}

Check() {

if [ -f "$FUNCTIONS" ] ; then
	grep "ulimit -S -c 0" $FUNCTIONS >/dev/null 2>&-
	if [ $? -eq 0 ]; then
	t_echo 2 " Core dump size is already set to zero: PASSES CHECK"
	t_echo 2 "     "
	else
	t_echo 0 " Core dump size has not been set:  FAILS CHECK"
	fi
fi

}

action=$1
 
   case ${action} in
        -[Ii]*)
        Intro
        ;;
        -[Ff]*)
        Fix
        ;;
        -[Vv]*)
        Check
        ;;
        *)
        t_echo 1 "        ERROR:Invalid arg $action"
        t_echo 1 "        ERROR:Usage $0 -[ivf] (I)ntro/(V)erify/(F)ix"
        exit 1
	;;
        esac




# List all files to save prior to changes this modules might make.
# Syntax is SAVEFILES='foo bar foobar'
#
SAVEFILES='/etc/rc.d/init.d/functions'
