:
#
# version 3.0 Sep 25 11:21:02 PDT 1998

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt
# Archibald, and Dan Farmer 1992, 1993, 1994, 1995, 1996, 1997, 1998, 1999, 2000
#
# The copyright holder disclaims all responsibility or liability with
# respect to its usage or its effect upon hardware or computer
# systems, and maintains copyright as set out in the "LICENSE"
# document which accompanies distribution.
#
 
TITANHOME=`pwd`
MYNAME=`basename $0`
PATH=/bin:/usr/bin:/sbin:$TITANHOME/lib
DATE=`/bin/date +%m%d%y%H%M`
RUNDATE=`/usr/bin/date +%Y%m%d%H%M`
OS=`uname -r`

FORWARDDIR="/usr/local/forward"
EXFORWARDDIR="\/usr\/local\/forward"
SENDMAILCONF="/etc/sendmail.cf"



# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi

. misc_functions.sh

if [ -x /usr/bin/nawk ];then
AWK=/bin/awk
elif [ -x /usr/bin/awk ];then
AWK=/bin/awk
fi


 
Intro() {
cat << EOF_INTRO
This script checks for restricted forwarding in the sendmail conf file, 
and restrict forward files to sysadmin controlled directory,
by default  $FORWARDDIR. It will also check the perms of the directory
to make sure it is really restricted.
EOF_INTRO
}

Check() {

   if grep "^[^#]*ForwardPath\=${FORWARDDIR}\/\.forward\.\$u[ ]*$" \
        $SENDMAILCONF ;then
        t_echo 2 "  forwarding restricted to $FORWARDDIR - PASSES CHECK "
   else
        t_echo 0 "  forwarding NOT restricted to $FORWARDDIR - FAILS CHECK "
   fi

   if [ -d "$FORWARDDIR" ];then
     /usr/bin/ls -ld $FORWARDDIR 2> /dev/null | $AWK '{
                        if ($1 != "drwxr-xr-x" ) {
                        exit 1;
                                }
                        if ($3 != "root" ) {
                        exit 1;
                                }
                        if ($4 != "sys" ) {
                        exit 1;
                                }
                      }'

      if [ $? -ne 0 ];then
       t_echo 0 "  $FORWARDDIR params - FAILS CHECK"
      else
        t_echo 2 "  $FORWARDDIR params - PASSES CHECK "
      fi
   else  
     t_echo 0 "  $FORWARDDIR missing - FAILS CHECK"
   fi

}


Fix() {

  if [ -d "$FORWARDDIR" ];then
    /usr/bin/ls -ld $FORWARDDIR 2> /dev/null | $AWK '{
                        if ($1 != "drwxr-xr-x" ) {
                        exit 1;
                                }
                        if ($3 != "root" ) {
                        exit 1;
                                }
                        if ($4 != "sys" ) {
                        exit 1;
                                }
                      }'

    if [ $? -ne 0 ];then
       t_echo 0 "  $FORWARDDIR params - FAILS CHECK . Fixing now..."
     if chmod 755 "$FORWARDDIR" && \
       chown root "$FORWARDDIR" && chgrp sys "$FORWARDDIR" \
       > /dev/null 2>&1; then
       t_echo 2 "  $FORWARDDIR params FIXED. "
     else
       t_echo 0 "  $FORWARDDIR params change FAILED "
       exit 1
     fi
    else
     t_echo 2 "  $FORWARDDIR params - PASSES CHECK "
    fi
  else  
   t_echo 0 "  $FORWARDDIR missing - Fixing now...."
   if mkdir -p "$FORWARDDIR" && chmod 755 "$FORWARDDIR" && \
        chown root "$FORWARDDIR" && chgrp sys "$FORWARDDIR" \
       > /dev/null 2>&1; then
        t_echo 2 "  $FORWARDDIR created. "
   else 
       t_echo 0 "  $FORWARDDIR creation FAILED "
       exit 1
   fi
  fi

   if grep "^[^#]*ForwardPath\=${FORWARDDIR}\/\.forward\.\$u[ ]*$" \
        $SENDMAILCONF > /dev/null 2>&1;then
        t_echo 2 "  forwarding restricted to $FORWARDDIR : PASSES CHECK "
   else
        t_echo 0 "  forwarding NOT restricted to $FORWARDDIR : Fixing now.. "
	ed - $SENDMAILCONF <<- EOED
	g/^[^#]*ForwardPath[ ]*\=/s/[ ]*\=.*/\=${EXFORWARDDIR}\/\.forward\.\$u/g
	.
	w
	q
	EOED
   fi
   if grep "^[^#]*ForwardPath\=${FORWARDDIR}\/\.forward\.\$u[ ]*$" \
        $SENDMAILCONF > /dev/null 2>&1;then :
   else
        t_echo 0 "  forwarding NOT restricted to $FORWARDDIR - ERROR FIX FAILED "
   fi

}

 
action=$1
case $action in
 -[Ff]*)
Fix
;;
 -[Vv]*)
Check
;;
 -[Ii]*)
Intro
;;
 
*)
        echo "        ERROR:Invalid arg $action"
        echo "        ERROR:Usage $MYNAME -[ivf] (I)ntro/(V)erify/(F)ix"
 
        echo " "
;;
esac



# List all files to save prior to changes this modules might make.
# Syntax is SAVEFILES='foo bar foobar'
#
SAVEFILES='/etc/sendmail.cf /usr/local/forward'
