:
#
# version 3.0 Sep 25 11:21:02 PDT 1998
# version 3.0.1 Mon Dec 14 10:53:10 PST 1998 change line 60-63 to pass a dot before "$$"
# version 3.0.3 Fri Jan  8 12:42:25 PST 1999 bpowell; for FILE loop in Fix()
# version 3.0.5 Fri Feb  18 12:42:25 PST 1999 bpowell; fix for solaris 7

# Modified Oct 2000 to work for Red Hat 6.2
# Erik Ginorio <eginorio@cisco.com>

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1992, 1993, 1994, 1995, 1996, 1997, 1998, 1999, 2000
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 

# setup
TITANHOME=`pwd`
PATH=/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`
DATE=`/bin/date +%m%d%y%H%M`

#
# suck in some lib functions (t_echo, etc.)
#
. misc_functions.sh


# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi


Intro() {

cat << EOF
 
    Simply comments out all the snmpd daemons start up files and 
    moves aside the config files it uses to start. Snmpd give out more 
    information than you really want it to. Who needs a port scanner 
    if snmpdx is running?

EOF

}

Fix() {
	if [ -f /etc/rc.d/init.d/snmpd ]; then
		SNMPD=/etc/rc.d/init.d/snmpd
		cp $SNMPD $SNMPD.ORIG.$DATE
		cp /etc/rc.d/init.d/snmpd /etc/rc.d/init.d/snmpd.ORIG.$DATE
		t_echo 2 " Saving original $SNMPD to $SNMPD.ORIG.$DATE "
		ed - /etc/rc.d/init.d/snmpd <<- !
			g/^\#/s/^\#//
			g/^/s/^/\#/
			w
			q
		!
		t_echo 2 " Disabling $SNMPD "
	fi
	if [ -f /etc/snmp/snmpd.conf ]; then
		mv /etc/snmp/snmpd.conf /etc/snmp/snmpd.conf.ORIG.$DATE
		t_echo 2 " Saving original config files "
		chmod 0100 /usr/share/snmp/
		t_echo 0 " Changing permissions on /usr/share/snmp/ "
	fi

}

Check() {
# don't fly off the hook - make sure it's there
if [ -f /etc/rc.d/init.d/snmpd ]; then
# ok, now test it to make sure it's all commented out
   if [ `awk '{print $1}' /etc/rc.d/init.d/snmpd|grep -v "^\#"|wc -l` != 0 ]; then
	t_echo 0 " Snmpd daemon is enabled - FAILS CHECK"
	exit 1
   else
        t_echo 2 " Snmpd doesn't start at boot time - PASSES CHECK" 
   fi
fi
}

action=$1

   case ${action} in
	-[Ii]*)
	Intro
	;;
	-[Ff]*)
	Fix
	;;
	-[Vv]*)
	Check
	;;
	*)
        t_echo 1 "        ERROR:Invalid arg $action"
        t_echo 1 "        ERROR:Usage $0 -[ivf] (I)ntro/(V)erify/(F)ix"
	exit 1;;
	esac



# List all files to save prior to changes this modules might make.
# Syntax is SAVEFILES='foo bar foobar'
#
SAVEFILES='/etc/rc.d/rc2.d/S??snmpdx /etc/rc.d/rc3.d/S??snmpdx'
