:
# nuke-portmap.sh
# version 4.0

umask 022
# This tools suite was writen by and is copyrighted by Brad Powell, Matt
# Archibald, and Dan Farmer 1992, 1993, 1994, 1995, 1996, 1997, 1998
# with input from Casper Dik, and Alec Muffet.
# Basic skeleton script+ some part from inetd.sh modified for FreeBSD.
# Derek Werthmuller 6/25/2000
#
# The copyright holder disclaims all responsibility or liability with
# respect to its usage or its effect upon hardware or computer
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution.

# setup
TITANHOME=`pwd`
PATH=/usr/ucb:/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`
OS=`uname -r`
HOST=`uname -n`
DATE=`/bin/date +%Y%m%d%H%M`
SAVEFILES='/etc/rc.conf'

. misc_functions.sh

# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi

Intro() {

cat << EOF
 $MYNAME - 
 Note: Use this module with caution. 
 This program copies /etc/inetd.conf to /etc/inetd.conf.ORIG-DATE.  Then makes an
 addition to /etc/rc.conf to turn off portmapper from starting at startup.
 
EOF

}


Fix() {

 if [ -f /etc/rc.conf  ]; then
  t_echo 2 " File /etc/rc.conf exists - Backing up to rc.conf.${DATE}"
  cp /etc/rc.conf /etc/rc.conf.${DATE}
 
 else
  t_echo 2 " /etc/rc.conf doesn't exist Creating.. "
  touch /etc/rc.conf
 fi

 t_echo 0 " Disabling portmapper.."
 t_echo 0 " The original version is saved as /etc/rc.conf.${DATE}"

 ed - /etc/rc.conf <<-!
g/^portmap_/s/^portmap_/#\ portmap_/g
/sysinstall
a
.
a
portmap_enable="NO"   # set to "YES" to enable portmapper 
.
w
q
!

 t_echo 2 " Changing /etc/rc.conf to mode 644 ..."

}


Check() {

 if [ -f /etc/rc.conf ]; then
  t_echo 2 " File /etc/rc.conf exists - Checking..."
 else
  t_echo 1 "ERROR     could not find /etc/rc.conf"
  exit 1
 fi

if  grep -i '^portmap_enable *= *"no"' /etc/rc.conf
  then
  t_echo 2 "Passes check portmapper is disabled"
else
  t_echo 1 "ERROR    portmapper is enabled"
fi

}

action=$1
        case ${action} in
	-[Ii]*)
	Intro
	;;
         -[Ff]*)
        Fix
        ;;
        -[Vv]*)
        Check
        ;;
        *)
        t_echo 1 " ERROR - Invalid arg $action"
        t_echo 1 " ERROR - Usage $MYNAME -[ivf] (I)ntro/(V)erify/(F)ix"
        t_echo 1 " "
        ;;
        esac

