:
# vold.sh
# version 3.0 Sep 25 11:21:02 PDT 1998
# version 3.4 Wed Feb 16 08:33:18 PST 2000 savefile variable added
# version 4.0

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1994, 1995, 1996, 1997, 1998, 1999, 2000
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 

# setup
TITANHOME=`pwd`
PATH=/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`
DATE=`/bin/date +%m%d%y%H%M`
SAVEFILES='/etc/rc2.d/S??volmgt /etc/vold.conf'
OS=`uname -r`

# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi

#
# suck in some lib functions (t_echo, etc.)
#
. misc_functions.sh

Intro() {
cat << EOF

 $MYNAME This program simply moves aside /etc/vold.conf and /usr/sbin/vold 
 so that vold does not start at system boot.

EOF

}

Check() {

if [ -f /etc/rc2.d/S??volmgt -a -x /usr/sbin/vold ] ; then
   t_echo 0 " "
   t_echo 0 " File /etc/rc2.d/S??volmgt and /usr/sbin/vold exists - FAILS CHECK "
   t_echo 2 " "
   exit 1
else
   t_echo 1 "      Could not find /etc/rc2.d/S??volmgt - PASSES CHECK "
  exit 1
fi 
}

Fix() {

if [ -f /etc/rc2.d/S??volmgt -a -x /usr/sbin/vold ] ; then
   t_echo 0 " " 
   t_echo 2 " Moving aside /etc/vold.conf to /etc/vold.conf.ORIG "
		mv /etc/vold.conf /etc/vold.conf.ORIG.$DATE
   t_echo 2 " "
   t_echo 2 " Now moving aside /usr/sbin/vold to /usr/sbin/vold.ORIG "
		mv /usr/sbin/vold /usr/sbin/vold.ORIG.$DATE
		chmod 100 /usr/sbin/vold.ORIG.$DATE
else
  t_echo 1 "/etc/rc2.d/S??volmgt doesn't seem to exist; exiting"
  exit 1
fi
}

action=$1
case $action in
 -[Ff]*)
Fix
;;
 -[Vv]*)
Check
;;
 -[Ii]*)
Intro
;;

*)
        t_echo 1 "        ERROR:Invalid arg $action"
        t_echo 1 "        ERROR:Usage $MYNAME -[ivf] (I)ntro/(V)erify/(F)ix"
        t_echo 1 " "
;;
esac

 
#finis
