:
# aset.sh 
# version 3.4 Wed Feb 16 08:33:18 PST 2000 savefile variable added
# version 4.0

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1994, 1995, 1996, 1997, 1998, 1999, 2000
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 

# contributed by <jason.rhoads@sabernet.net>

# setup
TITANHOME=`pwd`
PATH=/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`
DATE=`/bin/date +%m%d%y%H%M`
SAVEFILES='/usr/aset/asetenv'
OS=`uname -r`
ASET_DIR="/usr/aset"
ASET_LEVEL="high"

# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi

. misc_functions.sh

Intro() {

cat << EOF

 $MYNAME - This program is a wrapper around the Solaris Automated 
 Security Enhancement Tool (ASET).

 ASET will be executed with a security level of "$ASET_LEVEL" when
 run in Fix Mode.  See aset(1M) for more details.
 
EOF
}

#
# Run ASET 
#
Fix() {

 # disable the firewall task (redundant with disable_ip_holes.sh)
 grep "^TASKS=\"firewall" $ASET_DIR/asetenv > /dev/null 2>&-
 if [ $? -eq 0 ]; then
    t_echo 1 "Disabling ASET firewall task - asetenv saved as asetenv.ORIG.$DATE"
    cp -p $ASET_DIR/asetenv $ASET_DIR/asetenv.ORIG.$DATE
ed - $ASET_DIR/asetenv << EOEF
g/^TASKS=\"firewall /s//TASKS=\"/
w
q
EOEF

 fi

 $ASET_DIR/aset -l $ASET_LEVEL
}

#
# Verify ASET is installed
#
Check() {

	if [ ! -f $ASET_DIR/aset ]; then
	  t_echo 1 "ASET not installed - FAILS CHECK"
	t_echo 3 " "
	t_echo 3 "Titan Recommendation: (aset.sh -f) Install ASET  "
	t_echo 3 "Note - may require access to Solaris installation CD to pkgadd the ASET package."
	t_echo 3 "Note - ASET configuration should be run in Medium or High mode Titan runs in high"
	t_echo 3 "mode by default. "
	t_echo 3 " "
	t_echo 3 "======================================================================== "

      exit 1
	else
	  t_echo 1 "ASET installed - PASSES CHECK"
    fi
}

#
# Main section here

action=$1
case $action in
	-[Ii]*)
	Intro
	;;
	 -[Ff]*)
	  Fix
	 ;;
	 -[Vv]*)
	  Check
	 ;;
	 *)
 	 t_echo 1 " "
	 t_echo 1 "        ERROR:Invalid arg $action"
	 t_echo 1 "        ERROR:Usage $MYNAME -[ivf] (I)ntro/(V)erify/(F)ix"
 	 t_echo 1 " "
 	;;
esac
