:
# disable-ping-echo.sh
# version 3.0 Sep 25 11:21:02 PDT 1998
# version 3.0.1 Thu Nov  5 13:06:19 PST 1998 bpowell: new check to see
# if you already had a line, so we don't keep adding one in if you
# run -F multiple times
# version 3.0.3  Fri Jan  8 18:42:25 PST 1999 bpowell: for i loop in Fix()
# version 3.4 Wed Feb 16 08:33:18 PST 2000 savefile variable added
# version 4.0.10 Fri Apr  6 07:47:10 PDT 2001

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1994, 1995, 1996, 1997, 1998, 1999, 2000, 2001
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 

# setup
TITANHOME=`pwd`
PATH=/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`
DATE=`/bin/date +%m%d%y%H%M`
SAVEFILES='/etc/rc2.d/S??inet /etc/rc3.d/S??inet'

# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi

. misc_functions.sh

Intro() {

cat << EOF
  $MYNAME - This disables ip_respond_to_echo_broadcast so that
  specific ping crashes don't work. The program modifies /etc/rc2.d/S??inet

	ndd -set /dev/ip ip_respond_to_echo_broadcast 0 
EOF

}

Fix() {
if [ -f /etc/rc2.d/S??inet -o /etc/rc3.d/S??inet ]; then
for FILE in `ls /etc/rc*.d/S??inet`
do
 grep "ip_respond_to_echo_broadcast" $FILE >/dev/null 2>&-
   if [ $? -ne 0 ]; then

	t_echo 0 "        Adding the new ndd command"

ed - $FILE <<- !
a
ndd -set /dev/ip ip_respond_to_echo_broadcast 0
.
w
q
!

   t_echo 2 "	Modifications to $FILE complete"

	else t_echo 0 " Error - ip_respond_to_echo_broadcast is already set"
fi
done
fi
	t_echo 2 "	"
}

Check() {
 grep "ip_respond_to_echo_broadcast" /etc/rc2.d/S??inet >/dev/null 2>&-
   if [ $? -eq 0 ]; then
    t_echo 1 "         Ping echo response denied - PASSES CHECK"
    t_echo 2 " "
   else
    t_echo 0 "         Ping echo response allowed - FAILS CHECK"
        t_echo 3 " "
        t_echo 3 "Titan Recommendation: (disable-ping-echo.sh -f) Set all systems to not respond"
        t_echo 3 "to echo broadcast (ping -s 10.x.x.255)  by changing the network device driver"        
        t_echo 3 " "
        t_echo 3 "    ndd -set /dev/ip ip_respond_to_echo_broadcast 0 "
        t_echo 3 " "
        t_echo 3 "======================================================================== "

    exit 1
   fi
}

action=$1
case ${action} in
	-[Ii])
	Intro
	;;
	-[Ff]*)
	Fix
	;;
	-[Vv]*)
	Check
	;;
	*)
        t_echo 1 "         ERROR:Invalid arg $action"
        t_echo 1 "         ERROR:Usage $MYNAME -[ivf] (I)ntro/(V)erify/(F)ix"
        t_echo 1 " "
;;
esac
