:
# fix-modes.sh
# $Id: fix-modes,v 2.3 1998/11/04 15:41:32 casper Exp $
# slight Titan modes to check for OS type and run the proper binary
# wrapper for Casper Dik's fix-modes
# version 3.0.3 Tue Jan  5 15:49:31 PST 1999  bpowell
# version 3.0.5 Tue Feb 16 12:23:36 PST 1999 bpowell bug fix to run $MODES -f then $MODES
# version 3.4 Wed Feb 16 08:33:18 PST 2000 savefile variable added
# version 4.0

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt
# Archibald, and Dan Farmer 1994, 1995, 1996, 1997, 1998, 1999, 2000
#
# The copyright holder disclaims all responsibility or liability with
# respect to its usage or its effect upon hardware or computer
# systems, and maintains copyright as set out in the "LICENSE"
# document which accompan
#
# Only tested for 5.2-5.8
 
TITANHOME=`pwd`
PATH=/usr/sbin:/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`
DATE=`/bin/date +%m%d%y%H%M`
SAVEFILES='/var/sadm/install/contents'
root=/
OS=`uname -r`
. misc_functions.sh

case "`uname -r`" in
5.[2-9]*) ;;
*)  
	t_echo 1 " $MYNAME - Only supported on SunOS 5.2 thru 5.9" 1>&2 
	t_echo 1 "	(Solaris 2.2 through Solaris 9)" 1>&2 
	exit 1;;
esac

# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi
 
ARCH=`uname -p`
PWD=`/usr/bin/pwd`
TYPE="$ARCH-$OS"
t_echo 3 $TYPE

case ${TYPE} in

  *sparc*-5.[2-7]) MODES="secure-modes.sparc-sol5";export MODES;;

  *sparc*-5.[8]) MODES="secure-modes.sparc-sol8";export MODES;;

  *sparc*-5.[9]) MODES="secure-modes.sparc-sol9";export MODES;;

  *86*-5.[2-7]) MODES="secure-modes.x86-sol5";export MODES;;

  *86*-5.[8-9]) MODES="secure-modes.x86-sol8";export MODES;;

  *) t_echo 1 "No valid OS for fix-modes - ERROR"
     exit 1
;;
esac

Intro() {
 
cat << EOF

 $MYNAME - This program is a Titan wrapper for Casper Dik's fix-modes
 program. Many other options are allowed in the full fix-modes distribution 
 than the ones Titan uses. Look in the "optional" sub-directory of Titan for
  a full distribution of Caspers fix-modes.

 Titan uses fix-modes to change default file permissions to a saner than 
 origionally shipped setting. This is somewhat redundant to file-own.sh and
 ziplock.sh, but is included because different system types (or system admins)
 may prefer this method.
 
EOF

}

Fix() {

# force secure.modes to change the modes by passing it the "-f" flag
$MODES -f

# Now we run $MODES without any flags to create the contents.mods 

$MODES

# continue with clean-up
if [ ! -f /var/sadm/install/contents.mods ]
then
	find /var/sadm -xdev \( -perm -020 -o -perm -002 \) ! -type l -print |
        echo xargs  chmod og-w
	touch /var/adm/messages
	chmod og-w /var/adm/messages /var/log/syslog*
	chmod 600 /var/log/authlog*

if grep -s 666 /usr/lib/newsyslog >/dev/null
    then
            echo "sed -e s/666/644/g /usr/lib/newsyslog > /usr/lib/newsyslog.$DATE"
        else   
            sed -e s/666/644/g /usr/lib/newsyslog > /usr/lib/newsyslog.$DATE
        fi
	chmod 555 /usr/lib/newsyslog.$DATE
	chgrp sys /usr/lib/newsyslog.$DATE

if [ ! -f /usr/lib/newsyslog.FCS ]; then
	mv /usr/lib/newsyslog /usr/lib/newsyslog.FCS
fi
	mv /usr/lib/newsyslog.$DATE /usr/lib/newsyslog
	
if [ ! -f /var/lp/logs/lpNet ];  then
        touch /var/lp/logs/lpNet /var/lp/logs/lpsched
    fi
    chown lp /var/lp/logs/lpNet* /var/lp/logs/lpsched*
    chgrp lp /var/lp/logs/lpNet* /var/lp/logs/lpsched*
    chmod 644 /var/lp/logs/lpNet* /var/lp/logs/lpsched*
# Misc leftovers from installation time.
# For a number of those, a default umask of 022 is advised
 chmod -f og-w /etc/inet/* /etc/hostname.* /var/log/sysidconfig.log \
 /var/saf/_log /var/sadm/install/.pkg.lock /var/sadm/install/.lockfile \
 /var/adm/log/asppp.log /var/adm/vold.log /etc/mnttab /etc/rmtab
 chmod -fR og-w /var/statmon
fi

}

Check() {
# just run secure-modes with the debug flag so it doen't change anything
# just reports on things

t_echo 3 $MODES
$MODES -d

}

 
action=$1
case ${action} in
        -[Ii]*)
        Intro
        ;;
         -[Ff]*)
        Fix
        ;;
        -[Vv]*)
        Check
        ;;
*)
        t_echo 1 "        ERROR:Invalid arg $action"
        t_echo 1 "        ERROR:Usage $MYNAME -[ivf] (I)ntro/(V)erify/(F)ix"
        t_echo 1 " "
;;
esac
